<?php
/**
* Plugin WDD_avatars
*
* @package	PLX
* @version	1.0
* @date	20/09/16
* @author Bronco
**/

/*


?>
<?php if(!defined('PLX_ROOT')) exit; ?>
    
	<?php if($plxShow->plxMotor->plxRecord_coms): ?>
		<div id="comments">
			<h1><?php echo $plxShow->artNbCom() ?></h1>

			<div id="paginate_container">
				<ul class="paginate_content">
<?php  
$fichier=explode('&',basename($_SERVER['REQUEST_URI']));
$fichier=$fichier[0];
$fichier=urlencode($fichier.'-COMMENTS.html');

if ($cache=cache_read($fichier)){echo $cache;} else{ cache_start();?>
					<?php while($plxShow->plxMotor->plxRecord_coms->loop()): # On boucle sur les commentaires ?>
					<li>
						<?php $auteur=$plxShow->plxMotor->plxRecord_coms->f('author');?>
						<div id="<?php $plxShow->comId(); ?>" class="comment">
							<div class="avatar <?php echo $auteur ?>"><?php string2avatar($auteur); ?> <?php echo substr($auteur,0,10); ?></div>
							
*/

class WDD_avatars extends plxPlugin {
	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);

		
		
		
		# Declaration d'un hook (existant ou nouveau)
		$this->addHook('showAvatar','showAvatar');

		
	}

	# Activation / desactivation
	public function OnActivate() {
		# code à executer à l’activation du plugin
	}
	public function OnDeactivate() {
		# code à executer à la désactivation du plugin
	}
	

	########################################
	# HOOKS
	########################################


	########################################
	# showAvatar
	########################################
	# Description:
	public function showAvatar(){
		global $plxShow,$plxMotor;
		$auteur=$plxShow->plxMotor->plxRecord_coms->f('author');
		echo '<div class="avatar '.$auteur.'" style="background:url('.$plxMotor->urlRewrite($this->string2avatar($auteur)).') '.$this->string2color($auteur).'"></div>';
	}

	private function string2avatar($chaine){
		global $plxShow;
		$max=120;$file=$chaine.'.jpg';
		$chaine=strtolower($chaine);
		if ($chaine!='bronco'){

			// vire les non alphanum
			$chaine = preg_replace('#[^a-zA-Z0-9]#', '', $chaine);

			$a="a b c d e f g h i j k l m n o p q r s t u v w x y z 0 1 2 3 4 5 6 7 8 9";
			$b="f e d c b a 9 8 7 6 f e d c b a 9 8 7 6 f e d c b a f e d c b a 9 8 7 6";
			

			$a=explode(' ',$a);
			$b=explode(' ',$b);	
			 // couleur
			$couleur=str_replace($a,$b,$chaine);
			$len=strlen($couleur);
			if ($len<6){
				if ($len<3){
					$couleur.=str_repeat('0',3-$len);
				} else if ($len>3){
					$couleur.=str_repeat('0',6-$len); 
				}
			}
			$couleur='#'.substr($couleur,-6,6);
			// avatar
			$temp=preg_replace('#[^0-9]#', '', md5($chaine));
			$code[3]=(integer)substr($temp,0,3);
			$code[2]=(integer)substr($temp,0,2);
			$code[1]=(integer)substr($temp,0,1);

			if ($code[3]<=$max){$file=$code[3].'.png';}
			else if ($code[2]<=$max){$file=$code[2].'.png';}
			else if ($code[1]>0){$file=$code[1].'.png';}
			else{$file='1.png';}

			return PLX_PLUGINS.'WDD_avatars/avatars/'.$file;
		}else{
			return PLX_PLUGINS.'WDD_avatars/avatars/admin.png';
		}

		
	}
	private function string2color($chaine){
		if (strtolower($chaine)=='bronco'){return '';}
		//vire accents (merci HollandaisVolant ^^ )
		$chaine = html_entity_decode($chaine, ENT_QUOTES, 'UTF-8');
		$chaine = htmlentities($chaine, ENT_QUOTES, 'UTF-8');
		$chaine = preg_replace('#&(.)(acute|grave|circ|uml|cedil|tilde|ring|slash|caron);#', '$1', $chaine);
		
		$a="A B C D E F G H I J K L M N O P Q R S T U V W X Y Z a b c d e f g h i j k l m n o p q r s t u v w x y z - _ . ' & ( ) | [ ] { } @ ° + = $ * % ! ? § /";
		$b="f e d c b a 9 8 7 6 f e d c b a 9 8 7 6 f e d c b a 0 1 2 3 4 5 0 1 2 3 4 5 0 1 2 3 4 5 0 1 2 3 4 5 0 1 2 3 4 5 6 7 8 9 a b c d e f 1 2 3 4 5 6 7 8 9";
		$a=explode(' ',$a);
		$b=explode(' ',$b);	

		$chaine=str_replace($a,$b,$chaine);
		$chaine=str_replace(' ','9',$chaine);
		
		$len=strlen($chaine);
		if ($len<6){
			if ($len<3){
				$chaine.=str_repeat('0',3-$len);
			} else if ($len>3){
				$chaine.=str_repeat('0',6-$len); 
			}
		}
		
		$chaine='#'.substr($chaine,-6,6);
		return $chaine;
	}
	

}





/* Pense-bete:
 * Récuperer des etres du fichier eters.xml
 *	$this->getParam("<nom du etre>")
 *	$this-> setParam ("1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_CONFIG_PATH
 * PLX_PLUGINS
 * PLX_CONFIG_PATH
 * PLX_ADMIN (true si on est dans admin)
 * PLX_CHARSET
 * PLX_VERSION
 * PLX_FEED
 *
 * Appel de HOOK dans un thème
 *	eval($plxShow->callHook("ThemeEndHead","1"))  ou eval($plxShow->callHook("ThemeEndHead",array("1","2")))
 *	ou $retour=$plxShow->callHook("ThemeEndHead","1"));
 */